package gregapi.render;

import net.minecraft.block.Block;
import net.minecraft.client.renderer.RenderBlocks;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.world.IBlockAccess;

import org.lwjgl.opengl.GL11;

import cpw.mods.fml.client.registry.ISimpleBlockRenderingHandler;

/**
 * @author Gregorius Techneticies
 */
public class RendererBlockTextured implements ISimpleBlockRenderingHandler {
	public final int mRenderID;
	public static RendererBlockTextured INSTANCE;
	
	public RendererBlockTextured(int aRenderID) {
		INSTANCE = this;
		mRenderID = aRenderID;
	}
	
    @Override
	public void renderInventoryBlock(Block aBlock, int aMetaData, int aModelID, RenderBlocks aRenderer) {
		aRenderer.setRenderBoundsFromBlock(aBlock);
    	if (aBlock instanceof IRenderedBlock) {
        	GL11.glRotatef(90, 0, 1, 0);
        	GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
			boolean tNeedsToSetBounds = true;
    		IRenderedBlockObject tRenderer = ((IRenderedBlock)aBlock).passRenderingToObject((short)aMetaData);
    		if (tRenderer == null) {
	        	for (byte aSide = 0; aSide < 6; aSide++) for (int i = 0, j = ((IRenderedBlock)aBlock).getRenderPasses(aSide, (short)aMetaData); i < j; i++) {
	        		Tessellator.instance.startDrawingQuads();
	        		if (((IRenderedBlock)aBlock).setBlockBounds(i, aSide, (short)aMetaData)) tNeedsToSetBounds = true; else {if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F); tNeedsToSetBounds = false;}
	            	switch(aSide) {
	            	case 0: Tessellator.instance.setNormal( 0, -1,  0); renderNegativeYFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, aSide, (short)aMetaData), !tNeedsToSetBounds); break;
	            	case 1: Tessellator.instance.setNormal( 0,  1,  0); renderPositiveYFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, aSide, (short)aMetaData), !tNeedsToSetBounds); break;
	            	case 2: Tessellator.instance.setNormal( 0,  0, -1); renderNegativeZFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, aSide, (short)aMetaData), !tNeedsToSetBounds); break;
	            	case 3: Tessellator.instance.setNormal( 0,  0,  1); renderPositiveZFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, aSide, (short)aMetaData), !tNeedsToSetBounds); break;
	            	case 4: Tessellator.instance.setNormal(-1,  0,  0); renderNegativeXFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, aSide, (short)aMetaData), !tNeedsToSetBounds); break;
	            	case 5: Tessellator.instance.setNormal( 1,  0,  0); renderPositiveXFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, aSide, (short)aMetaData), !tNeedsToSetBounds); break;
	            	}
	            	Tessellator.instance.draw();
	        	}
    		} else {
    			if (!tRenderer.renderItem(aBlock, aRenderer)) for (byte aSide = 0; aSide < 6; aSide++) for (int i = 0, j = tRenderer.getRenderPasses(aBlock, aSide); i < j; i++) {
	        		Tessellator.instance.startDrawingQuads();
	        		if (tRenderer.setBlockBounds(aBlock, i, aSide)) tNeedsToSetBounds = true; else {if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F); tNeedsToSetBounds = false;}
	            	switch(aSide) {
	            	case 0: Tessellator.instance.setNormal( 0, -1,  0); renderNegativeYFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, aSide), !tNeedsToSetBounds); break;
	            	case 1: Tessellator.instance.setNormal( 0,  1,  0); renderPositiveYFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, aSide), !tNeedsToSetBounds); break;
	            	case 2: Tessellator.instance.setNormal( 0,  0, -1); renderNegativeZFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, aSide), !tNeedsToSetBounds); break;
	            	case 3: Tessellator.instance.setNormal( 0,  0,  1); renderPositiveZFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, aSide), !tNeedsToSetBounds); break;
	            	case 4: Tessellator.instance.setNormal(-1,  0,  0); renderNegativeXFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, aSide), !tNeedsToSetBounds); break;
	            	case 5: Tessellator.instance.setNormal( 1,  0,  0); renderPositiveXFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, aSide), !tNeedsToSetBounds); break;
	            	}
	            	Tessellator.instance.draw();
	        	}
    		}
    	}
		aRenderer.setRenderBoundsFromBlock(aBlock);
    	GL11.glTranslatef(0.5F, 0.5F, 0.5F);
    }
    
    @Override
	public boolean renderWorldBlock(IBlockAccess aWorld, int aX, int aY, int aZ, Block aBlock, int aModelID, RenderBlocks aRenderer) {
        Tessellator.instance.setBrightness(983055);
		boolean rReturn = false;
		aRenderer.setRenderBoundsFromBlock(aBlock);
    	if (aBlock instanceof IRenderedBlock) {
    		IRenderedBlockObject tRenderer = ((IRenderedBlock)aBlock).passRenderingToObject(aWorld, aX, aY, aZ);
    		if (tRenderer == null) {
    			boolean tNeedsToSetBounds = true;
    			for (byte aSide = 0; aSide < 6; aSide++) for (int i = 0, j = ((IRenderedBlock)aBlock).getRenderPasses(aSide, aWorld, aX, aY, aZ); i < j; i++) {
    				if (((IRenderedBlock)aBlock).setBlockBounds(i, aSide, aWorld, aX, aY, aZ)) tNeedsToSetBounds = true; else {if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F); tNeedsToSetBounds = false;}
    				switch(aSide) {
                	case 0: if (renderNegativeYFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, aSide, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = true; break;
                	case 1: if (renderPositiveYFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, aSide, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = true; break;
                	case 2: if (renderNegativeZFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, aSide, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = true; break;
                	case 3: if (renderPositiveZFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, aSide, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = true; break;
                	case 4: if (renderNegativeXFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, aSide, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = true; break;
                	case 5: if (renderPositiveXFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, aSide, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = true; break;
                	}
    			}
    		} else {
    			if (tRenderer.renderBlock(aBlock, aRenderer)) {
    				rReturn = true;
    			} else {
        			boolean tNeedsToSetBounds = true;
    				for (byte aSide = 0; aSide < 6; aSide++) for (int i = 0, j = tRenderer.getRenderPasses(aBlock, aSide); i < j; i++) {
	    				if (tRenderer.setBlockBounds(aBlock, i, aSide)) tNeedsToSetBounds = true; else {if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F); tNeedsToSetBounds = false;}
	    				switch(aSide) {
	                	case 0: if (renderNegativeYFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, aSide), !tNeedsToSetBounds)) rReturn = true; break;
	                	case 1: if (renderPositiveYFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, aSide), !tNeedsToSetBounds)) rReturn = true; break;
	                	case 2: if (renderNegativeZFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, aSide), !tNeedsToSetBounds)) rReturn = true; break;
	                	case 3: if (renderPositiveZFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, aSide), !tNeedsToSetBounds)) rReturn = true; break;
	                	case 4: if (renderNegativeXFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, aSide), !tNeedsToSetBounds)) rReturn = true; break;
	                	case 5: if (renderPositiveXFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, aSide), !tNeedsToSetBounds)) rReturn = true; break;
	    				}
    				}
    			}
    		}
    	}
		aRenderer.setRenderBoundsFromBlock(aBlock);
    	return rReturn;
    }
    
    public static boolean renderNegativeYFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX, aY-1, aZ, 0)) return false;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aX, aFullBlock?aY-1:aY, aZ);
	        aRenderer.enableAO = true;
    	}
    	if (aIcon != null) aIcon.renderYNeg(aRenderer, aBlock, aX, aY, aZ, aBrightness);
    	aRenderer.flipTexture = false;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.5F;
		return true;
    }
    
    public static boolean renderPositiveYFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX, aY+1, aZ, 1)) return false;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aX, aFullBlock?aY+1:aY, aZ);
	        aRenderer.enableAO = true;
    	}
		if (aIcon != null) aIcon.renderYPos(aRenderer, aBlock, aX, aY, aZ, aBrightness);
    	aRenderer.flipTexture = false;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 1.0F;
		return true;
	}
    
    public static boolean renderNegativeZFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX, aY, aZ-1, 2)) return false;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aX, aY, aFullBlock?aZ-1:aZ);
	        aRenderer.enableAO = true;
    	}
		aRenderer.flipTexture = !aFullBlock;
    	if (aIcon != null) aIcon.renderZNeg(aRenderer, aBlock, aX, aY, aZ, aBrightness);
		aRenderer.flipTexture = false;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.8F;
		return true;
    }
    
    public static boolean renderPositiveZFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX, aY, aZ+1, 3)) return false;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aX, aY, aFullBlock?aZ+1:aZ);
	        aRenderer.enableAO = true;
    	}
    	if (aIcon != null) aIcon.renderZPos(aRenderer, aBlock, aX, aY, aZ, aBrightness);
    	aRenderer.flipTexture = false;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.8F;
		return true;
    }
    
    public static boolean renderNegativeXFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX-1, aY, aZ, 4)) return false;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aFullBlock?aX-1:aX, aY, aZ);
	        aRenderer.enableAO = true;
    	}
    	if (aIcon != null) aIcon.renderXNeg(aRenderer, aBlock, aX, aY, aZ, aBrightness);
    	aRenderer.flipTexture = false;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.6F;
		return true;
    }
    
    public static boolean renderPositiveXFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX+1, aY, aZ, 5)) return false;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aFullBlock?aX+1:aX, aY, aZ);
	        aRenderer.enableAO = true;
    	}
		aRenderer.flipTexture = !aFullBlock;
    	if (aIcon != null) aIcon.renderXPos(aRenderer, aBlock, aX, aY, aZ, aBrightness);
		aRenderer.flipTexture = false;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.6F;
		return true;
    }
    
    @Override
	public boolean shouldRender3DInInventory(int aModel) {
        return true;
    }
    
    @Override
	public int getRenderId() {
        return mRenderID;
    }
}